; TI-83 Assembler Program



;int_buffer:=label von grey_int fr startadresse der bildschirmseiten


putsprite:			;x=>b y=>c @mem=>hl
				;adress offset ausrechnen
	push bc
	push de

	push hl		;hl sichern (2x fr beide routinen)
	push hl

	ld d,$00		;y in de
	ld e,b
	sra e
	sra e
	sra e
	push de		;de in hl kopieren
	pop hl
	add hl,de		;hl+de (hl=2*x)
	add hl,hl		;32*(hl)
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl		;

	ld d,0		;y in de
	ld e,c
	add hl,de		;de und hl addieren (offset fertig rechnen)
				;war jetz 64*x+y in hl
	ld (addr_buff),hl	;adress offset speichern	

;einrckschritte
	ld a,%00000111
	and b
	ld (rot),a

;maske fr hintergrund

	ld de,(addr_buff)		;@screen adresse ausrechnen
	ld hl,(int_buffer)	;bedeutet: offset+startadresse
	add hl,de
	push hl
	pop de
	ld a,8
	pop hl			;screenmaske fr hintergrund und sprite

copyloop:
	ld (count),a		;counter (schleife muss 8 mal laufen)
	push hl			;@mem sichern
	ld a,(hl)			;byte von sprite (p1) in a
	ld b,a			;-"------------- in b
	ld a,8			;8 in a
	call addieren		;zu hl 8 addieren
	ld a,(hl)			;byte von sprite (p2) in a
	or b				;die beiden mit or verknpfen ---> nur wenn beide =0 dann 0 als maske

	ld b,a
	ld a,(rot)			;in a anzalh von rotation
	call einruecken		;maske um (rot) bits nach rechts schieben

	ld a,%11111111		;not bc
	xor b				
	ld b,a
	ld a,%11111111
	xor c
	ld c,a

	ld a,(de)			;byte von screen in a
	and b				;mit maske verknpfen
	ld b,a			;ergebniss zurck in maske
	push de			;@screen sichern
	call add64			;zu de 64 addieren
	ld a,(de)			;byte von screen in a
	and c				;mit maske verknpfen
	ld c,a			;zurck in maske
	pop de			;@screen zurckholen	
	pop hl			;@mem zurckholen

	ld a,(hl)			;sprite byte holen
	push de			;de sichern
	push bc			;bc in de kopieren (maske von bc in de)
	pop de			
	ld b,a			;a in b
	ld a,(rot)			;um (rot)bits nach rechts
	call einruecken		;sprite byte schieben
	
	ld a,b			;bc or de = maske (de) mit sprite (bc) verknpfen
	or d	
	ld b,a
	ld a,c
	or e
	ld c,a

	pop de			;@screen zurckholen
	ld a,b			;erstes byte in @screen
	ld (de),a
	push de			;@screen sichern
	call add64			;x+1 (@screen+64)
	ld a,c			;zweites byte in nchste spalte
	ld (de),a			;----
	pop de			;@screen adresse zurckholen

	inc hl			;nchstes sprite-byte
	inc de			;nachstes screen byte fr maske
	
	ld a,(count)		;counter-1
	dec a
	jr nz,copyloop		;schleife zuende ?


;maske fr hintergrund

	ld de,(addr_buff)		;@screen adresse ausrechnen
	ld hl,(int_buffer+2)	;bedeutet: offset+startadresse
	add hl,de
	push hl
	pop de
	ld a,8
	pop hl			;screenmaske fr hintergrund und sprite

copyloop2:
	ld (count),a		;counter (schleife muss 8 mal laufen)
	push hl			;@mem sichern
	ld a,(hl)			;byte von sprite (p1) in a
	ld b,a			;-"------------- in b
	ld a,8			;8 in a
	call addieren		;zu hl 8 addieren
	ld a,(hl)			;byte von sprite (p2) in a
	or b				;die beiden mit or verknpfen ---> nur wenn beide =0 dann 0 als maske

	ld b,a
	ld a,(rot)			;in a anzalh von rotation
	call einruecken		;maske um (rot) bits nach rechts schieben

	ld a,%11111111		;not bc
	xor b				
	ld b,a
	ld a,%11111111
	xor c
	ld c,a

	ld a,(de)			;byte von screen in a
	and b				;mit maske verknpfen
	ld b,a			;ergebniss zurck in maske
	push de			;@screen sichern
	call add64			;zu de 64 addieren
	ld a,(de)			;byte von screen in a
	and c				;mit maske verknpfen
	ld c,a			;zurck in maske
	pop de			;@screen zurckholen	

	ld a,(hl)			;sprite byte holen
	pop hl			;@mem zurckholen
	push de			;de sichern
	push bc			;bc in de kopieren (maske von bc in de)
	pop de			
	ld b,a			;a in b
	ld a,(rot)			;um (rot)bits nach rechts
	call einruecken		;sprite byte schieben
	
	ld a,b			;bc or de = maske (de) mit sprite (bc) verknpfen
	or d	
	ld b,a
	ld a,c
	or e
	ld c,a

	pop de			;@screen zurckholen
	ld a,b			;erstes byte in @screen
	ld (de),a
	push de			;@screen sichern
	call add64			;x+1 (@screen+64)
	ld a,c			;zweites byte in nchste spalte
	ld (de),a			;----
	pop de			;@screen adresse zurckholen

	inc hl			;nchstes sprite-byte
	inc de			;nachstes screen byte fr maske
	
	ld a,(count)		;counter-1
	dec a
	jr nz,copyloop2		;schleife zuende ?

	pop de
	pop bc
	ret	


store_bg:				;input: x=b; y=c; de=@buffer
	push hl	
	push bc

	call get_offset
	push hl

	push de
	ld de,(int_buffer)
	add hl,de
	pop de
	
	ld bc,08
	ldir
	
	push de
	ld de,56
	add hl,de
	pop de
	
	ld bc,08
	ldir

	pop hl
	push de
	ld de,(int_buffer+2)
	add hl,de
	pop de
	
	ld bc,08
	ldir
	
	push de
	ld de,56
	add hl,de
	pop de
	
	ld bc,08
	ldir

	pop bc
	pop hl
	ret
	
recall_bg:
	push hl
	push bc	

	call get_offset
	push hl
	push de
	ld de,(int_buffer)
	add hl,de
	pop de
	
	ex de,hl
	ld bc,08
	ldir

	push hl
	ld hl,56
	add hl,de
	pop de

	ex de,hl
	ld bc,08
	ldir

	pop de
	push hl
	ld hl,(int_buffer+2)
	add hl,de
	pop de
	
	ex de,hl
	ld bc,08
	ldir

	push hl
	ld hl,56
	add hl,de
	pop de
	
	ex de,hl
	ld bc,08
	ldir

	pop bc
	pop hl
	ret
	

get_offset:			;input: x=b; y=c;
				;output: hl=adress offset
	push de
	ld d,$00		;y in de
	ld e,b
	sra e			;
	sra e			;
	sra e			;
	push de		;de in hl kopieren
	pop hl
	add hl,de		;hl+de (hl=2*x)
	add hl,hl		;32*(hl)
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl		;

	ld d,0		;y in de
	ld e,c
	add hl,de		;de und hl addieren (offset fertig rechnen)
				;war jetz 64*x+y in hl
	pop de
	ret

einruecken:			;input: a=anzahl;b=wert
				;output: b=teil 1; c=teil 2;
	ld c,0
	cp 0
	jr z,ein_ende

ein_next1:
	srl b
	rr c
	dec a
	jp nz,ein_next1
ein_ende:
	ret		

addieren:			;input: a=summand; hl=summand ;geeignet fr unkompl. additionen <10
				;output: hl=summe
	inc hl
	dec a
	jr nz,addieren
	ret

add64:			;input: de=summand; 64=summand
				;output: de=resultat
	push hl
	ld hl,64
	add hl,de
	push hl
	pop de
	pop hl
	ret
	
fill_page:
	ld (hl),a
	push hl
	pop de
	inc de
	ld bc,767
	ldir
	ret

addr_buff:
	.dw $0000	
count:
	.db $00
rot:
	.db $00

.end
